import { createAggregatedClient } from "@smithy/smithy-client";
import { CodePipelineClient } from "./CodePipelineClient";
import { AcknowledgeJobCommand, } from "./commands/AcknowledgeJobCommand";
import { AcknowledgeThirdPartyJobCommand, } from "./commands/AcknowledgeThirdPartyJobCommand";
import { CreateCustomActionTypeCommand, } from "./commands/CreateCustomActionTypeCommand";
import { CreatePipelineCommand, } from "./commands/CreatePipelineCommand";
import { DeleteCustomActionTypeCommand, } from "./commands/DeleteCustomActionTypeCommand";
import { DeletePipelineCommand, } from "./commands/DeletePipelineCommand";
import { DeleteWebhookCommand, } from "./commands/DeleteWebhookCommand";
import { DeregisterWebhookWithThirdPartyCommand, } from "./commands/DeregisterWebhookWithThirdPartyCommand";
import { DisableStageTransitionCommand, } from "./commands/DisableStageTransitionCommand";
import { EnableStageTransitionCommand, } from "./commands/EnableStageTransitionCommand";
import { GetActionTypeCommand, } from "./commands/GetActionTypeCommand";
import { GetJobDetailsCommand, } from "./commands/GetJobDetailsCommand";
import { GetPipelineCommand } from "./commands/GetPipelineCommand";
import { GetPipelineExecutionCommand, } from "./commands/GetPipelineExecutionCommand";
import { GetPipelineStateCommand, } from "./commands/GetPipelineStateCommand";
import { GetThirdPartyJobDetailsCommand, } from "./commands/GetThirdPartyJobDetailsCommand";
import { ListActionExecutionsCommand, } from "./commands/ListActionExecutionsCommand";
import { ListActionTypesCommand, } from "./commands/ListActionTypesCommand";
import { ListPipelineExecutionsCommand, } from "./commands/ListPipelineExecutionsCommand";
import { ListPipelinesCommand, } from "./commands/ListPipelinesCommand";
import { ListTagsForResourceCommand, } from "./commands/ListTagsForResourceCommand";
import { ListWebhooksCommand, } from "./commands/ListWebhooksCommand";
import { PollForJobsCommand } from "./commands/PollForJobsCommand";
import { PollForThirdPartyJobsCommand, } from "./commands/PollForThirdPartyJobsCommand";
import { PutActionRevisionCommand, } from "./commands/PutActionRevisionCommand";
import { PutApprovalResultCommand, } from "./commands/PutApprovalResultCommand";
import { PutJobFailureResultCommand, } from "./commands/PutJobFailureResultCommand";
import { PutJobSuccessResultCommand, } from "./commands/PutJobSuccessResultCommand";
import { PutThirdPartyJobFailureResultCommand, } from "./commands/PutThirdPartyJobFailureResultCommand";
import { PutThirdPartyJobSuccessResultCommand, } from "./commands/PutThirdPartyJobSuccessResultCommand";
import { PutWebhookCommand } from "./commands/PutWebhookCommand";
import { RegisterWebhookWithThirdPartyCommand, } from "./commands/RegisterWebhookWithThirdPartyCommand";
import { RetryStageExecutionCommand, } from "./commands/RetryStageExecutionCommand";
import { RollbackStageCommand, } from "./commands/RollbackStageCommand";
import { StartPipelineExecutionCommand, } from "./commands/StartPipelineExecutionCommand";
import { StopPipelineExecutionCommand, } from "./commands/StopPipelineExecutionCommand";
import { TagResourceCommand } from "./commands/TagResourceCommand";
import { UntagResourceCommand, } from "./commands/UntagResourceCommand";
import { UpdateActionTypeCommand, } from "./commands/UpdateActionTypeCommand";
import { UpdatePipelineCommand, } from "./commands/UpdatePipelineCommand";
const commands = {
    AcknowledgeJobCommand,
    AcknowledgeThirdPartyJobCommand,
    CreateCustomActionTypeCommand,
    CreatePipelineCommand,
    DeleteCustomActionTypeCommand,
    DeletePipelineCommand,
    DeleteWebhookCommand,
    DeregisterWebhookWithThirdPartyCommand,
    DisableStageTransitionCommand,
    EnableStageTransitionCommand,
    GetActionTypeCommand,
    GetJobDetailsCommand,
    GetPipelineCommand,
    GetPipelineExecutionCommand,
    GetPipelineStateCommand,
    GetThirdPartyJobDetailsCommand,
    ListActionExecutionsCommand,
    ListActionTypesCommand,
    ListPipelineExecutionsCommand,
    ListPipelinesCommand,
    ListTagsForResourceCommand,
    ListWebhooksCommand,
    PollForJobsCommand,
    PollForThirdPartyJobsCommand,
    PutActionRevisionCommand,
    PutApprovalResultCommand,
    PutJobFailureResultCommand,
    PutJobSuccessResultCommand,
    PutThirdPartyJobFailureResultCommand,
    PutThirdPartyJobSuccessResultCommand,
    PutWebhookCommand,
    RegisterWebhookWithThirdPartyCommand,
    RetryStageExecutionCommand,
    RollbackStageCommand,
    StartPipelineExecutionCommand,
    StopPipelineExecutionCommand,
    TagResourceCommand,
    UntagResourceCommand,
    UpdateActionTypeCommand,
    UpdatePipelineCommand,
};
export class CodePipeline extends CodePipelineClient {
}
createAggregatedClient(commands, CodePipeline);
