import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_DeregisterWebhookWithThirdPartyCommand, se_DeregisterWebhookWithThirdPartyCommand, } from "../protocols/Aws_json1_1";
export { $Command };
export class DeregisterWebhookWithThirdPartyCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("CodePipeline_20150709", "DeregisterWebhookWithThirdParty", {})
    .n("CodePipelineClient", "DeregisterWebhookWithThirdPartyCommand")
    .f(void 0, void 0)
    .ser(se_DeregisterWebhookWithThirdPartyCommand)
    .de(de_DeregisterWebhookWithThirdPartyCommand)
    .build() {
}
