import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import { AcknowledgeJobCommandInput, AcknowledgeJobCommandOutput } from "../commands/AcknowledgeJobCommand";
import { AcknowledgeThirdPartyJobCommandInput, AcknowledgeThirdPartyJobCommandOutput } from "../commands/AcknowledgeThirdPartyJobCommand";
import { CreateCustomActionTypeCommandInput, CreateCustomActionTypeCommandOutput } from "../commands/CreateCustomActionTypeCommand";
import { CreatePipelineCommandInput, CreatePipelineCommandOutput } from "../commands/CreatePipelineCommand";
import { DeleteCustomActionTypeCommandInput, DeleteCustomActionTypeCommandOutput } from "../commands/DeleteCustomActionTypeCommand";
import { DeletePipelineCommandInput, DeletePipelineCommandOutput } from "../commands/DeletePipelineCommand";
import { DeleteWebhookCommandInput, DeleteWebhookCommandOutput } from "../commands/DeleteWebhookCommand";
import { DeregisterWebhookWithThirdPartyCommandInput, DeregisterWebhookWithThirdPartyCommandOutput } from "../commands/DeregisterWebhookWithThirdPartyCommand";
import { DisableStageTransitionCommandInput, DisableStageTransitionCommandOutput } from "../commands/DisableStageTransitionCommand";
import { EnableStageTransitionCommandInput, EnableStageTransitionCommandOutput } from "../commands/EnableStageTransitionCommand";
import { GetActionTypeCommandInput, GetActionTypeCommandOutput } from "../commands/GetActionTypeCommand";
import { GetJobDetailsCommandInput, GetJobDetailsCommandOutput } from "../commands/GetJobDetailsCommand";
import { GetPipelineCommandInput, GetPipelineCommandOutput } from "../commands/GetPipelineCommand";
import { GetPipelineExecutionCommandInput, GetPipelineExecutionCommandOutput } from "../commands/GetPipelineExecutionCommand";
import { GetPipelineStateCommandInput, GetPipelineStateCommandOutput } from "../commands/GetPipelineStateCommand";
import { GetThirdPartyJobDetailsCommandInput, GetThirdPartyJobDetailsCommandOutput } from "../commands/GetThirdPartyJobDetailsCommand";
import { ListActionExecutionsCommandInput, ListActionExecutionsCommandOutput } from "../commands/ListActionExecutionsCommand";
import { ListActionTypesCommandInput, ListActionTypesCommandOutput } from "../commands/ListActionTypesCommand";
import { ListPipelineExecutionsCommandInput, ListPipelineExecutionsCommandOutput } from "../commands/ListPipelineExecutionsCommand";
import { ListPipelinesCommandInput, ListPipelinesCommandOutput } from "../commands/ListPipelinesCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "../commands/ListTagsForResourceCommand";
import { ListWebhooksCommandInput, ListWebhooksCommandOutput } from "../commands/ListWebhooksCommand";
import { PollForJobsCommandInput, PollForJobsCommandOutput } from "../commands/PollForJobsCommand";
import { PollForThirdPartyJobsCommandInput, PollForThirdPartyJobsCommandOutput } from "../commands/PollForThirdPartyJobsCommand";
import { PutActionRevisionCommandInput, PutActionRevisionCommandOutput } from "../commands/PutActionRevisionCommand";
import { PutApprovalResultCommandInput, PutApprovalResultCommandOutput } from "../commands/PutApprovalResultCommand";
import { PutJobFailureResultCommandInput, PutJobFailureResultCommandOutput } from "../commands/PutJobFailureResultCommand";
import { PutJobSuccessResultCommandInput, PutJobSuccessResultCommandOutput } from "../commands/PutJobSuccessResultCommand";
import { PutThirdPartyJobFailureResultCommandInput, PutThirdPartyJobFailureResultCommandOutput } from "../commands/PutThirdPartyJobFailureResultCommand";
import { PutThirdPartyJobSuccessResultCommandInput, PutThirdPartyJobSuccessResultCommandOutput } from "../commands/PutThirdPartyJobSuccessResultCommand";
import { PutWebhookCommandInput, PutWebhookCommandOutput } from "../commands/PutWebhookCommand";
import { RegisterWebhookWithThirdPartyCommandInput, RegisterWebhookWithThirdPartyCommandOutput } from "../commands/RegisterWebhookWithThirdPartyCommand";
import { RetryStageExecutionCommandInput, RetryStageExecutionCommandOutput } from "../commands/RetryStageExecutionCommand";
import { RollbackStageCommandInput, RollbackStageCommandOutput } from "../commands/RollbackStageCommand";
import { StartPipelineExecutionCommandInput, StartPipelineExecutionCommandOutput } from "../commands/StartPipelineExecutionCommand";
import { StopPipelineExecutionCommandInput, StopPipelineExecutionCommandOutput } from "../commands/StopPipelineExecutionCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "../commands/TagResourceCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "../commands/UntagResourceCommand";
import { UpdateActionTypeCommandInput, UpdateActionTypeCommandOutput } from "../commands/UpdateActionTypeCommand";
import { UpdatePipelineCommandInput, UpdatePipelineCommandOutput } from "../commands/UpdatePipelineCommand";
/**
 * serializeAws_json1_1AcknowledgeJobCommand
 */
export declare const se_AcknowledgeJobCommand: (input: AcknowledgeJobCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1AcknowledgeThirdPartyJobCommand
 */
export declare const se_AcknowledgeThirdPartyJobCommand: (input: AcknowledgeThirdPartyJobCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreateCustomActionTypeCommand
 */
export declare const se_CreateCustomActionTypeCommand: (input: CreateCustomActionTypeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1CreatePipelineCommand
 */
export declare const se_CreatePipelineCommand: (input: CreatePipelineCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteCustomActionTypeCommand
 */
export declare const se_DeleteCustomActionTypeCommand: (input: DeleteCustomActionTypeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeletePipelineCommand
 */
export declare const se_DeletePipelineCommand: (input: DeletePipelineCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteWebhookCommand
 */
export declare const se_DeleteWebhookCommand: (input: DeleteWebhookCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeregisterWebhookWithThirdPartyCommand
 */
export declare const se_DeregisterWebhookWithThirdPartyCommand: (input: DeregisterWebhookWithThirdPartyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DisableStageTransitionCommand
 */
export declare const se_DisableStageTransitionCommand: (input: DisableStageTransitionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1EnableStageTransitionCommand
 */
export declare const se_EnableStageTransitionCommand: (input: EnableStageTransitionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetActionTypeCommand
 */
export declare const se_GetActionTypeCommand: (input: GetActionTypeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetJobDetailsCommand
 */
export declare const se_GetJobDetailsCommand: (input: GetJobDetailsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetPipelineCommand
 */
export declare const se_GetPipelineCommand: (input: GetPipelineCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetPipelineExecutionCommand
 */
export declare const se_GetPipelineExecutionCommand: (input: GetPipelineExecutionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetPipelineStateCommand
 */
export declare const se_GetPipelineStateCommand: (input: GetPipelineStateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetThirdPartyJobDetailsCommand
 */
export declare const se_GetThirdPartyJobDetailsCommand: (input: GetThirdPartyJobDetailsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListActionExecutionsCommand
 */
export declare const se_ListActionExecutionsCommand: (input: ListActionExecutionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListActionTypesCommand
 */
export declare const se_ListActionTypesCommand: (input: ListActionTypesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListPipelineExecutionsCommand
 */
export declare const se_ListPipelineExecutionsCommand: (input: ListPipelineExecutionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListPipelinesCommand
 */
export declare const se_ListPipelinesCommand: (input: ListPipelinesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListTagsForResourceCommand
 */
export declare const se_ListTagsForResourceCommand: (input: ListTagsForResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListWebhooksCommand
 */
export declare const se_ListWebhooksCommand: (input: ListWebhooksCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PollForJobsCommand
 */
export declare const se_PollForJobsCommand: (input: PollForJobsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PollForThirdPartyJobsCommand
 */
export declare const se_PollForThirdPartyJobsCommand: (input: PollForThirdPartyJobsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutActionRevisionCommand
 */
export declare const se_PutActionRevisionCommand: (input: PutActionRevisionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutApprovalResultCommand
 */
export declare const se_PutApprovalResultCommand: (input: PutApprovalResultCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutJobFailureResultCommand
 */
export declare const se_PutJobFailureResultCommand: (input: PutJobFailureResultCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutJobSuccessResultCommand
 */
export declare const se_PutJobSuccessResultCommand: (input: PutJobSuccessResultCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutThirdPartyJobFailureResultCommand
 */
export declare const se_PutThirdPartyJobFailureResultCommand: (input: PutThirdPartyJobFailureResultCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutThirdPartyJobSuccessResultCommand
 */
export declare const se_PutThirdPartyJobSuccessResultCommand: (input: PutThirdPartyJobSuccessResultCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1PutWebhookCommand
 */
export declare const se_PutWebhookCommand: (input: PutWebhookCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1RegisterWebhookWithThirdPartyCommand
 */
export declare const se_RegisterWebhookWithThirdPartyCommand: (input: RegisterWebhookWithThirdPartyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1RetryStageExecutionCommand
 */
export declare const se_RetryStageExecutionCommand: (input: RetryStageExecutionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1RollbackStageCommand
 */
export declare const se_RollbackStageCommand: (input: RollbackStageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StartPipelineExecutionCommand
 */
export declare const se_StartPipelineExecutionCommand: (input: StartPipelineExecutionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1StopPipelineExecutionCommand
 */
export declare const se_StopPipelineExecutionCommand: (input: StopPipelineExecutionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1TagResourceCommand
 */
export declare const se_TagResourceCommand: (input: TagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UntagResourceCommand
 */
export declare const se_UntagResourceCommand: (input: UntagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateActionTypeCommand
 */
export declare const se_UpdateActionTypeCommand: (input: UpdateActionTypeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdatePipelineCommand
 */
export declare const se_UpdatePipelineCommand: (input: UpdatePipelineCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * deserializeAws_json1_1AcknowledgeJobCommand
 */
export declare const de_AcknowledgeJobCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AcknowledgeJobCommandOutput>;
/**
 * deserializeAws_json1_1AcknowledgeThirdPartyJobCommand
 */
export declare const de_AcknowledgeThirdPartyJobCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AcknowledgeThirdPartyJobCommandOutput>;
/**
 * deserializeAws_json1_1CreateCustomActionTypeCommand
 */
export declare const de_CreateCustomActionTypeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateCustomActionTypeCommandOutput>;
/**
 * deserializeAws_json1_1CreatePipelineCommand
 */
export declare const de_CreatePipelineCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreatePipelineCommandOutput>;
/**
 * deserializeAws_json1_1DeleteCustomActionTypeCommand
 */
export declare const de_DeleteCustomActionTypeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteCustomActionTypeCommandOutput>;
/**
 * deserializeAws_json1_1DeletePipelineCommand
 */
export declare const de_DeletePipelineCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeletePipelineCommandOutput>;
/**
 * deserializeAws_json1_1DeleteWebhookCommand
 */
export declare const de_DeleteWebhookCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteWebhookCommandOutput>;
/**
 * deserializeAws_json1_1DeregisterWebhookWithThirdPartyCommand
 */
export declare const de_DeregisterWebhookWithThirdPartyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeregisterWebhookWithThirdPartyCommandOutput>;
/**
 * deserializeAws_json1_1DisableStageTransitionCommand
 */
export declare const de_DisableStageTransitionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DisableStageTransitionCommandOutput>;
/**
 * deserializeAws_json1_1EnableStageTransitionCommand
 */
export declare const de_EnableStageTransitionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<EnableStageTransitionCommandOutput>;
/**
 * deserializeAws_json1_1GetActionTypeCommand
 */
export declare const de_GetActionTypeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetActionTypeCommandOutput>;
/**
 * deserializeAws_json1_1GetJobDetailsCommand
 */
export declare const de_GetJobDetailsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetJobDetailsCommandOutput>;
/**
 * deserializeAws_json1_1GetPipelineCommand
 */
export declare const de_GetPipelineCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetPipelineCommandOutput>;
/**
 * deserializeAws_json1_1GetPipelineExecutionCommand
 */
export declare const de_GetPipelineExecutionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetPipelineExecutionCommandOutput>;
/**
 * deserializeAws_json1_1GetPipelineStateCommand
 */
export declare const de_GetPipelineStateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetPipelineStateCommandOutput>;
/**
 * deserializeAws_json1_1GetThirdPartyJobDetailsCommand
 */
export declare const de_GetThirdPartyJobDetailsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetThirdPartyJobDetailsCommandOutput>;
/**
 * deserializeAws_json1_1ListActionExecutionsCommand
 */
export declare const de_ListActionExecutionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListActionExecutionsCommandOutput>;
/**
 * deserializeAws_json1_1ListActionTypesCommand
 */
export declare const de_ListActionTypesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListActionTypesCommandOutput>;
/**
 * deserializeAws_json1_1ListPipelineExecutionsCommand
 */
export declare const de_ListPipelineExecutionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListPipelineExecutionsCommandOutput>;
/**
 * deserializeAws_json1_1ListPipelinesCommand
 */
export declare const de_ListPipelinesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListPipelinesCommandOutput>;
/**
 * deserializeAws_json1_1ListTagsForResourceCommand
 */
export declare const de_ListTagsForResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsForResourceCommandOutput>;
/**
 * deserializeAws_json1_1ListWebhooksCommand
 */
export declare const de_ListWebhooksCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListWebhooksCommandOutput>;
/**
 * deserializeAws_json1_1PollForJobsCommand
 */
export declare const de_PollForJobsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PollForJobsCommandOutput>;
/**
 * deserializeAws_json1_1PollForThirdPartyJobsCommand
 */
export declare const de_PollForThirdPartyJobsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PollForThirdPartyJobsCommandOutput>;
/**
 * deserializeAws_json1_1PutActionRevisionCommand
 */
export declare const de_PutActionRevisionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutActionRevisionCommandOutput>;
/**
 * deserializeAws_json1_1PutApprovalResultCommand
 */
export declare const de_PutApprovalResultCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutApprovalResultCommandOutput>;
/**
 * deserializeAws_json1_1PutJobFailureResultCommand
 */
export declare const de_PutJobFailureResultCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutJobFailureResultCommandOutput>;
/**
 * deserializeAws_json1_1PutJobSuccessResultCommand
 */
export declare const de_PutJobSuccessResultCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutJobSuccessResultCommandOutput>;
/**
 * deserializeAws_json1_1PutThirdPartyJobFailureResultCommand
 */
export declare const de_PutThirdPartyJobFailureResultCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutThirdPartyJobFailureResultCommandOutput>;
/**
 * deserializeAws_json1_1PutThirdPartyJobSuccessResultCommand
 */
export declare const de_PutThirdPartyJobSuccessResultCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutThirdPartyJobSuccessResultCommandOutput>;
/**
 * deserializeAws_json1_1PutWebhookCommand
 */
export declare const de_PutWebhookCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutWebhookCommandOutput>;
/**
 * deserializeAws_json1_1RegisterWebhookWithThirdPartyCommand
 */
export declare const de_RegisterWebhookWithThirdPartyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RegisterWebhookWithThirdPartyCommandOutput>;
/**
 * deserializeAws_json1_1RetryStageExecutionCommand
 */
export declare const de_RetryStageExecutionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RetryStageExecutionCommandOutput>;
/**
 * deserializeAws_json1_1RollbackStageCommand
 */
export declare const de_RollbackStageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RollbackStageCommandOutput>;
/**
 * deserializeAws_json1_1StartPipelineExecutionCommand
 */
export declare const de_StartPipelineExecutionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartPipelineExecutionCommandOutput>;
/**
 * deserializeAws_json1_1StopPipelineExecutionCommand
 */
export declare const de_StopPipelineExecutionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StopPipelineExecutionCommandOutput>;
/**
 * deserializeAws_json1_1TagResourceCommand
 */
export declare const de_TagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TagResourceCommandOutput>;
/**
 * deserializeAws_json1_1UntagResourceCommand
 */
export declare const de_UntagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UntagResourceCommandOutput>;
/**
 * deserializeAws_json1_1UpdateActionTypeCommand
 */
export declare const de_UpdateActionTypeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateActionTypeCommandOutput>;
/**
 * deserializeAws_json1_1UpdatePipelineCommand
 */
export declare const de_UpdatePipelineCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdatePipelineCommandOutput>;
