import { HttpHandlerOptions as __HttpHandlerOptions } from "@smithy/types";
import { CodePipelineClient } from "./CodePipelineClient";
import {
  AcknowledgeJobCommandInput,
  AcknowledgeJobCommandOutput,
} from "./commands/AcknowledgeJobCommand";
import {
  AcknowledgeThirdPartyJobCommandInput,
  AcknowledgeThirdPartyJobCommandOutput,
} from "./commands/AcknowledgeThirdPartyJobCommand";
import {
  CreateCustomActionTypeCommandInput,
  CreateCustomActionTypeCommandOutput,
} from "./commands/CreateCustomActionTypeCommand";
import {
  CreatePipelineCommandInput,
  CreatePipelineCommandOutput,
} from "./commands/CreatePipelineCommand";
import {
  DeleteCustomActionTypeCommandInput,
  DeleteCustomActionTypeCommandOutput,
} from "./commands/DeleteCustomActionTypeCommand";
import {
  DeletePipelineCommandInput,
  DeletePipelineCommandOutput,
} from "./commands/DeletePipelineCommand";
import {
  DeleteWebhookCommandInput,
  DeleteWebhookCommandOutput,
} from "./commands/DeleteWebhookCommand";
import {
  DeregisterWebhookWithThirdPartyCommandInput,
  DeregisterWebhookWithThirdPartyCommandOutput,
} from "./commands/DeregisterWebhookWithThirdPartyCommand";
import {
  DisableStageTransitionCommandInput,
  DisableStageTransitionCommandOutput,
} from "./commands/DisableStageTransitionCommand";
import {
  EnableStageTransitionCommandInput,
  EnableStageTransitionCommandOutput,
} from "./commands/EnableStageTransitionCommand";
import {
  GetActionTypeCommandInput,
  GetActionTypeCommandOutput,
} from "./commands/GetActionTypeCommand";
import {
  GetJobDetailsCommandInput,
  GetJobDetailsCommandOutput,
} from "./commands/GetJobDetailsCommand";
import {
  GetPipelineCommandInput,
  GetPipelineCommandOutput,
} from "./commands/GetPipelineCommand";
import {
  GetPipelineExecutionCommandInput,
  GetPipelineExecutionCommandOutput,
} from "./commands/GetPipelineExecutionCommand";
import {
  GetPipelineStateCommandInput,
  GetPipelineStateCommandOutput,
} from "./commands/GetPipelineStateCommand";
import {
  GetThirdPartyJobDetailsCommandInput,
  GetThirdPartyJobDetailsCommandOutput,
} from "./commands/GetThirdPartyJobDetailsCommand";
import {
  ListActionExecutionsCommandInput,
  ListActionExecutionsCommandOutput,
} from "./commands/ListActionExecutionsCommand";
import {
  ListActionTypesCommandInput,
  ListActionTypesCommandOutput,
} from "./commands/ListActionTypesCommand";
import {
  ListPipelineExecutionsCommandInput,
  ListPipelineExecutionsCommandOutput,
} from "./commands/ListPipelineExecutionsCommand";
import {
  ListPipelinesCommandInput,
  ListPipelinesCommandOutput,
} from "./commands/ListPipelinesCommand";
import {
  ListTagsForResourceCommandInput,
  ListTagsForResourceCommandOutput,
} from "./commands/ListTagsForResourceCommand";
import {
  ListWebhooksCommandInput,
  ListWebhooksCommandOutput,
} from "./commands/ListWebhooksCommand";
import {
  PollForJobsCommandInput,
  PollForJobsCommandOutput,
} from "./commands/PollForJobsCommand";
import {
  PollForThirdPartyJobsCommandInput,
  PollForThirdPartyJobsCommandOutput,
} from "./commands/PollForThirdPartyJobsCommand";
import {
  PutActionRevisionCommandInput,
  PutActionRevisionCommandOutput,
} from "./commands/PutActionRevisionCommand";
import {
  PutApprovalResultCommandInput,
  PutApprovalResultCommandOutput,
} from "./commands/PutApprovalResultCommand";
import {
  PutJobFailureResultCommandInput,
  PutJobFailureResultCommandOutput,
} from "./commands/PutJobFailureResultCommand";
import {
  PutJobSuccessResultCommandInput,
  PutJobSuccessResultCommandOutput,
} from "./commands/PutJobSuccessResultCommand";
import {
  PutThirdPartyJobFailureResultCommandInput,
  PutThirdPartyJobFailureResultCommandOutput,
} from "./commands/PutThirdPartyJobFailureResultCommand";
import {
  PutThirdPartyJobSuccessResultCommandInput,
  PutThirdPartyJobSuccessResultCommandOutput,
} from "./commands/PutThirdPartyJobSuccessResultCommand";
import {
  PutWebhookCommandInput,
  PutWebhookCommandOutput,
} from "./commands/PutWebhookCommand";
import {
  RegisterWebhookWithThirdPartyCommandInput,
  RegisterWebhookWithThirdPartyCommandOutput,
} from "./commands/RegisterWebhookWithThirdPartyCommand";
import {
  RetryStageExecutionCommandInput,
  RetryStageExecutionCommandOutput,
} from "./commands/RetryStageExecutionCommand";
import {
  RollbackStageCommandInput,
  RollbackStageCommandOutput,
} from "./commands/RollbackStageCommand";
import {
  StartPipelineExecutionCommandInput,
  StartPipelineExecutionCommandOutput,
} from "./commands/StartPipelineExecutionCommand";
import {
  StopPipelineExecutionCommandInput,
  StopPipelineExecutionCommandOutput,
} from "./commands/StopPipelineExecutionCommand";
import {
  TagResourceCommandInput,
  TagResourceCommandOutput,
} from "./commands/TagResourceCommand";
import {
  UntagResourceCommandInput,
  UntagResourceCommandOutput,
} from "./commands/UntagResourceCommand";
import {
  UpdateActionTypeCommandInput,
  UpdateActionTypeCommandOutput,
} from "./commands/UpdateActionTypeCommand";
import {
  UpdatePipelineCommandInput,
  UpdatePipelineCommandOutput,
} from "./commands/UpdatePipelineCommand";
export interface CodePipeline {
  acknowledgeJob(
    args: AcknowledgeJobCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<AcknowledgeJobCommandOutput>;
  acknowledgeJob(
    args: AcknowledgeJobCommandInput,
    cb: (err: any, data?: AcknowledgeJobCommandOutput) => void
  ): void;
  acknowledgeJob(
    args: AcknowledgeJobCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: AcknowledgeJobCommandOutput) => void
  ): void;
  acknowledgeThirdPartyJob(
    args: AcknowledgeThirdPartyJobCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<AcknowledgeThirdPartyJobCommandOutput>;
  acknowledgeThirdPartyJob(
    args: AcknowledgeThirdPartyJobCommandInput,
    cb: (err: any, data?: AcknowledgeThirdPartyJobCommandOutput) => void
  ): void;
  acknowledgeThirdPartyJob(
    args: AcknowledgeThirdPartyJobCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: AcknowledgeThirdPartyJobCommandOutput) => void
  ): void;
  createCustomActionType(
    args: CreateCustomActionTypeCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<CreateCustomActionTypeCommandOutput>;
  createCustomActionType(
    args: CreateCustomActionTypeCommandInput,
    cb: (err: any, data?: CreateCustomActionTypeCommandOutput) => void
  ): void;
  createCustomActionType(
    args: CreateCustomActionTypeCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: CreateCustomActionTypeCommandOutput) => void
  ): void;
  createPipeline(
    args: CreatePipelineCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<CreatePipelineCommandOutput>;
  createPipeline(
    args: CreatePipelineCommandInput,
    cb: (err: any, data?: CreatePipelineCommandOutput) => void
  ): void;
  createPipeline(
    args: CreatePipelineCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: CreatePipelineCommandOutput) => void
  ): void;
  deleteCustomActionType(
    args: DeleteCustomActionTypeCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeleteCustomActionTypeCommandOutput>;
  deleteCustomActionType(
    args: DeleteCustomActionTypeCommandInput,
    cb: (err: any, data?: DeleteCustomActionTypeCommandOutput) => void
  ): void;
  deleteCustomActionType(
    args: DeleteCustomActionTypeCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeleteCustomActionTypeCommandOutput) => void
  ): void;
  deletePipeline(
    args: DeletePipelineCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeletePipelineCommandOutput>;
  deletePipeline(
    args: DeletePipelineCommandInput,
    cb: (err: any, data?: DeletePipelineCommandOutput) => void
  ): void;
  deletePipeline(
    args: DeletePipelineCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeletePipelineCommandOutput) => void
  ): void;
  deleteWebhook(
    args: DeleteWebhookCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeleteWebhookCommandOutput>;
  deleteWebhook(
    args: DeleteWebhookCommandInput,
    cb: (err: any, data?: DeleteWebhookCommandOutput) => void
  ): void;
  deleteWebhook(
    args: DeleteWebhookCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeleteWebhookCommandOutput) => void
  ): void;
  deregisterWebhookWithThirdParty(): Promise<DeregisterWebhookWithThirdPartyCommandOutput>;
  deregisterWebhookWithThirdParty(
    args: DeregisterWebhookWithThirdPartyCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeregisterWebhookWithThirdPartyCommandOutput>;
  deregisterWebhookWithThirdParty(
    args: DeregisterWebhookWithThirdPartyCommandInput,
    cb: (err: any, data?: DeregisterWebhookWithThirdPartyCommandOutput) => void
  ): void;
  deregisterWebhookWithThirdParty(
    args: DeregisterWebhookWithThirdPartyCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeregisterWebhookWithThirdPartyCommandOutput) => void
  ): void;
  disableStageTransition(
    args: DisableStageTransitionCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DisableStageTransitionCommandOutput>;
  disableStageTransition(
    args: DisableStageTransitionCommandInput,
    cb: (err: any, data?: DisableStageTransitionCommandOutput) => void
  ): void;
  disableStageTransition(
    args: DisableStageTransitionCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DisableStageTransitionCommandOutput) => void
  ): void;
  enableStageTransition(
    args: EnableStageTransitionCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<EnableStageTransitionCommandOutput>;
  enableStageTransition(
    args: EnableStageTransitionCommandInput,
    cb: (err: any, data?: EnableStageTransitionCommandOutput) => void
  ): void;
  enableStageTransition(
    args: EnableStageTransitionCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: EnableStageTransitionCommandOutput) => void
  ): void;
  getActionType(
    args: GetActionTypeCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetActionTypeCommandOutput>;
  getActionType(
    args: GetActionTypeCommandInput,
    cb: (err: any, data?: GetActionTypeCommandOutput) => void
  ): void;
  getActionType(
    args: GetActionTypeCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetActionTypeCommandOutput) => void
  ): void;
  getJobDetails(
    args: GetJobDetailsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetJobDetailsCommandOutput>;
  getJobDetails(
    args: GetJobDetailsCommandInput,
    cb: (err: any, data?: GetJobDetailsCommandOutput) => void
  ): void;
  getJobDetails(
    args: GetJobDetailsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetJobDetailsCommandOutput) => void
  ): void;
  getPipeline(
    args: GetPipelineCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetPipelineCommandOutput>;
  getPipeline(
    args: GetPipelineCommandInput,
    cb: (err: any, data?: GetPipelineCommandOutput) => void
  ): void;
  getPipeline(
    args: GetPipelineCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetPipelineCommandOutput) => void
  ): void;
  getPipelineExecution(
    args: GetPipelineExecutionCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetPipelineExecutionCommandOutput>;
  getPipelineExecution(
    args: GetPipelineExecutionCommandInput,
    cb: (err: any, data?: GetPipelineExecutionCommandOutput) => void
  ): void;
  getPipelineExecution(
    args: GetPipelineExecutionCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetPipelineExecutionCommandOutput) => void
  ): void;
  getPipelineState(
    args: GetPipelineStateCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetPipelineStateCommandOutput>;
  getPipelineState(
    args: GetPipelineStateCommandInput,
    cb: (err: any, data?: GetPipelineStateCommandOutput) => void
  ): void;
  getPipelineState(
    args: GetPipelineStateCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetPipelineStateCommandOutput) => void
  ): void;
  getThirdPartyJobDetails(
    args: GetThirdPartyJobDetailsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetThirdPartyJobDetailsCommandOutput>;
  getThirdPartyJobDetails(
    args: GetThirdPartyJobDetailsCommandInput,
    cb: (err: any, data?: GetThirdPartyJobDetailsCommandOutput) => void
  ): void;
  getThirdPartyJobDetails(
    args: GetThirdPartyJobDetailsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetThirdPartyJobDetailsCommandOutput) => void
  ): void;
  listActionExecutions(
    args: ListActionExecutionsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListActionExecutionsCommandOutput>;
  listActionExecutions(
    args: ListActionExecutionsCommandInput,
    cb: (err: any, data?: ListActionExecutionsCommandOutput) => void
  ): void;
  listActionExecutions(
    args: ListActionExecutionsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListActionExecutionsCommandOutput) => void
  ): void;
  listActionTypes(): Promise<ListActionTypesCommandOutput>;
  listActionTypes(
    args: ListActionTypesCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListActionTypesCommandOutput>;
  listActionTypes(
    args: ListActionTypesCommandInput,
    cb: (err: any, data?: ListActionTypesCommandOutput) => void
  ): void;
  listActionTypes(
    args: ListActionTypesCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListActionTypesCommandOutput) => void
  ): void;
  listPipelineExecutions(
    args: ListPipelineExecutionsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListPipelineExecutionsCommandOutput>;
  listPipelineExecutions(
    args: ListPipelineExecutionsCommandInput,
    cb: (err: any, data?: ListPipelineExecutionsCommandOutput) => void
  ): void;
  listPipelineExecutions(
    args: ListPipelineExecutionsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListPipelineExecutionsCommandOutput) => void
  ): void;
  listPipelines(): Promise<ListPipelinesCommandOutput>;
  listPipelines(
    args: ListPipelinesCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListPipelinesCommandOutput>;
  listPipelines(
    args: ListPipelinesCommandInput,
    cb: (err: any, data?: ListPipelinesCommandOutput) => void
  ): void;
  listPipelines(
    args: ListPipelinesCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListPipelinesCommandOutput) => void
  ): void;
  listTagsForResource(
    args: ListTagsForResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListTagsForResourceCommandOutput>;
  listTagsForResource(
    args: ListTagsForResourceCommandInput,
    cb: (err: any, data?: ListTagsForResourceCommandOutput) => void
  ): void;
  listTagsForResource(
    args: ListTagsForResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListTagsForResourceCommandOutput) => void
  ): void;
  listWebhooks(): Promise<ListWebhooksCommandOutput>;
  listWebhooks(
    args: ListWebhooksCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListWebhooksCommandOutput>;
  listWebhooks(
    args: ListWebhooksCommandInput,
    cb: (err: any, data?: ListWebhooksCommandOutput) => void
  ): void;
  listWebhooks(
    args: ListWebhooksCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListWebhooksCommandOutput) => void
  ): void;
  pollForJobs(
    args: PollForJobsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<PollForJobsCommandOutput>;
  pollForJobs(
    args: PollForJobsCommandInput,
    cb: (err: any, data?: PollForJobsCommandOutput) => void
  ): void;
  pollForJobs(
    args: PollForJobsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: PollForJobsCommandOutput) => void
  ): void;
  pollForThirdPartyJobs(
    args: PollForThirdPartyJobsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<PollForThirdPartyJobsCommandOutput>;
  pollForThirdPartyJobs(
    args: PollForThirdPartyJobsCommandInput,
    cb: (err: any, data?: PollForThirdPartyJobsCommandOutput) => void
  ): void;
  pollForThirdPartyJobs(
    args: PollForThirdPartyJobsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: PollForThirdPartyJobsCommandOutput) => void
  ): void;
  putActionRevision(
    args: PutActionRevisionCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<PutActionRevisionCommandOutput>;
  putActionRevision(
    args: PutActionRevisionCommandInput,
    cb: (err: any, data?: PutActionRevisionCommandOutput) => void
  ): void;
  putActionRevision(
    args: PutActionRevisionCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: PutActionRevisionCommandOutput) => void
  ): void;
  putApprovalResult(
    args: PutApprovalResultCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<PutApprovalResultCommandOutput>;
  putApprovalResult(
    args: PutApprovalResultCommandInput,
    cb: (err: any, data?: PutApprovalResultCommandOutput) => void
  ): void;
  putApprovalResult(
    args: PutApprovalResultCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: PutApprovalResultCommandOutput) => void
  ): void;
  putJobFailureResult(
    args: PutJobFailureResultCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<PutJobFailureResultCommandOutput>;
  putJobFailureResult(
    args: PutJobFailureResultCommandInput,
    cb: (err: any, data?: PutJobFailureResultCommandOutput) => void
  ): void;
  putJobFailureResult(
    args: PutJobFailureResultCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: PutJobFailureResultCommandOutput) => void
  ): void;
  putJobSuccessResult(
    args: PutJobSuccessResultCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<PutJobSuccessResultCommandOutput>;
  putJobSuccessResult(
    args: PutJobSuccessResultCommandInput,
    cb: (err: any, data?: PutJobSuccessResultCommandOutput) => void
  ): void;
  putJobSuccessResult(
    args: PutJobSuccessResultCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: PutJobSuccessResultCommandOutput) => void
  ): void;
  putThirdPartyJobFailureResult(
    args: PutThirdPartyJobFailureResultCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<PutThirdPartyJobFailureResultCommandOutput>;
  putThirdPartyJobFailureResult(
    args: PutThirdPartyJobFailureResultCommandInput,
    cb: (err: any, data?: PutThirdPartyJobFailureResultCommandOutput) => void
  ): void;
  putThirdPartyJobFailureResult(
    args: PutThirdPartyJobFailureResultCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: PutThirdPartyJobFailureResultCommandOutput) => void
  ): void;
  putThirdPartyJobSuccessResult(
    args: PutThirdPartyJobSuccessResultCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<PutThirdPartyJobSuccessResultCommandOutput>;
  putThirdPartyJobSuccessResult(
    args: PutThirdPartyJobSuccessResultCommandInput,
    cb: (err: any, data?: PutThirdPartyJobSuccessResultCommandOutput) => void
  ): void;
  putThirdPartyJobSuccessResult(
    args: PutThirdPartyJobSuccessResultCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: PutThirdPartyJobSuccessResultCommandOutput) => void
  ): void;
  putWebhook(
    args: PutWebhookCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<PutWebhookCommandOutput>;
  putWebhook(
    args: PutWebhookCommandInput,
    cb: (err: any, data?: PutWebhookCommandOutput) => void
  ): void;
  putWebhook(
    args: PutWebhookCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: PutWebhookCommandOutput) => void
  ): void;
  registerWebhookWithThirdParty(): Promise<RegisterWebhookWithThirdPartyCommandOutput>;
  registerWebhookWithThirdParty(
    args: RegisterWebhookWithThirdPartyCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<RegisterWebhookWithThirdPartyCommandOutput>;
  registerWebhookWithThirdParty(
    args: RegisterWebhookWithThirdPartyCommandInput,
    cb: (err: any, data?: RegisterWebhookWithThirdPartyCommandOutput) => void
  ): void;
  registerWebhookWithThirdParty(
    args: RegisterWebhookWithThirdPartyCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: RegisterWebhookWithThirdPartyCommandOutput) => void
  ): void;
  retryStageExecution(
    args: RetryStageExecutionCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<RetryStageExecutionCommandOutput>;
  retryStageExecution(
    args: RetryStageExecutionCommandInput,
    cb: (err: any, data?: RetryStageExecutionCommandOutput) => void
  ): void;
  retryStageExecution(
    args: RetryStageExecutionCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: RetryStageExecutionCommandOutput) => void
  ): void;
  rollbackStage(
    args: RollbackStageCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<RollbackStageCommandOutput>;
  rollbackStage(
    args: RollbackStageCommandInput,
    cb: (err: any, data?: RollbackStageCommandOutput) => void
  ): void;
  rollbackStage(
    args: RollbackStageCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: RollbackStageCommandOutput) => void
  ): void;
  startPipelineExecution(
    args: StartPipelineExecutionCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<StartPipelineExecutionCommandOutput>;
  startPipelineExecution(
    args: StartPipelineExecutionCommandInput,
    cb: (err: any, data?: StartPipelineExecutionCommandOutput) => void
  ): void;
  startPipelineExecution(
    args: StartPipelineExecutionCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: StartPipelineExecutionCommandOutput) => void
  ): void;
  stopPipelineExecution(
    args: StopPipelineExecutionCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<StopPipelineExecutionCommandOutput>;
  stopPipelineExecution(
    args: StopPipelineExecutionCommandInput,
    cb: (err: any, data?: StopPipelineExecutionCommandOutput) => void
  ): void;
  stopPipelineExecution(
    args: StopPipelineExecutionCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: StopPipelineExecutionCommandOutput) => void
  ): void;
  tagResource(
    args: TagResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<TagResourceCommandOutput>;
  tagResource(
    args: TagResourceCommandInput,
    cb: (err: any, data?: TagResourceCommandOutput) => void
  ): void;
  tagResource(
    args: TagResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: TagResourceCommandOutput) => void
  ): void;
  untagResource(
    args: UntagResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UntagResourceCommandOutput>;
  untagResource(
    args: UntagResourceCommandInput,
    cb: (err: any, data?: UntagResourceCommandOutput) => void
  ): void;
  untagResource(
    args: UntagResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UntagResourceCommandOutput) => void
  ): void;
  updateActionType(
    args: UpdateActionTypeCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UpdateActionTypeCommandOutput>;
  updateActionType(
    args: UpdateActionTypeCommandInput,
    cb: (err: any, data?: UpdateActionTypeCommandOutput) => void
  ): void;
  updateActionType(
    args: UpdateActionTypeCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UpdateActionTypeCommandOutput) => void
  ): void;
  updatePipeline(
    args: UpdatePipelineCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UpdatePipelineCommandOutput>;
  updatePipeline(
    args: UpdatePipelineCommandInput,
    cb: (err: any, data?: UpdatePipelineCommandOutput) => void
  ): void;
  updatePipeline(
    args: UpdatePipelineCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UpdatePipelineCommandOutput) => void
  ): void;
}
export declare class CodePipeline
  extends CodePipelineClient
  implements CodePipeline {}
